@page "/game/{gameId}"

@using Microsoft.AspNetCore.WebUtilities
@using fsociety_web.Pages.Components
@inject Backend back
@inject NavigationManager navMan
@inject Observatory obz
@inject Waiter wagter
@inject JSIOp jsiop
@implements IDisposable

<div class="modal fade" id="leaveModal" tabindex="-1" role="dialog" aria-labelledby="leaveModalLabel" aria-hidden="true"><!-- leave modal -->
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="leaveModalLabel">Are you sure you want to quit?</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <p>@getQuitText()</p>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        <button type="button" class="btn btn-primary" data-dismiss="modal" @onclick="OnLeaveClick">Quit game</button>
      </div>
    </div>
  </div>
</div>

<div style="position: absolute; top: 0; left: 0; height: fit-content; width: 100%"><!-- timer -->
    <TimerComponent></TimerComponent>
</div>

<div id="game-component">
    @if(largeScreen){<div style="height: 24px;"></div>}else{<div style="height: 6px;"></div>}
    <div style="display: flex;"><!-- top bar -->
        <div><img src="/assets/fsoc.png" id="corner-logo"></div>
        <div style="flex-grow: 1;"></div>
        <div>
            <h1 style="text-align: center;">@if (statusData==null){<span>Loading game...</span>}else{@DisplayStatus(statusData.game_status)}</h1>
            <p style="text-align: center; color: @getRoundDisplayCol(); margin-bottom: 0;">@getRoundDisplay()</p>
        </div>
        <div style="flex-grow: 1;"></div>
        <div class="d-flex">
            <div>
                <button class="btn btn-primary" type="button" @onclick="OnFullscreenClick"><div style="filter: invert(100%) sepia(0%) saturate(7500%) hue-rotate(56deg) brightness(108%) contrast(102%);"><!-- all this just to make the black svg white -->
                    @if(isFullscreen){<img src="/assets/icons/fullscreen-exit.svg">}else{<img src="/assets/icons/arrows-fullscreen.svg">}</div></button>
            </div>
            <div style="width: 12px;"></div>
            <div>
                <button class="btn btn-warning" type="button" data-toggle="modal" data-target="#leaveModal"><img src="/assets/icons/x-octagon.svg"></button>
            </div>
        </div>
    </div>

    @if(isPortrait){ <!-- portrait blanket -->
        <div style="margin-top: 20vh; text-align: center;">
            <h2>Please rotate your display</h2>
            <p>The app works best in landscape</p>
            <img src="/assets/icons/arrow-repeat.svg" style="margin-top: 36px; width: 20vw; margin-bottom: 36px;">
        </div>
    }
    @if(statusData==null){ <!-- status-data loading spinner -->
        <div style="margin: 64px auto 0; text-align: center;">
            <div class="spinner-grow text-success" style="width: 7rem; height: 7rem;" role="status">
                <span class="sr-only">Loading...</span>
            </div>
        </div>
    }

    @if(statusData != null && !isPortrait){
        @if(largeScreen){<div style="height: 12px;"></div>}
    @if(IsInGame() || statusData.game_status=="LOBBY"){
    <div class="container-fluid">       <!-- main inner content -->
        <div class="row d-flex" style="height: @calcHeight(0);"> <!-- top row -->

            @if(statusData.game_status=="LOBBY"){
                <div class="col-1"></div>
                <ShareGameComponent></ShareGameComponent>
                <div class="col-1"></div>
            }else if (IsInGame()){ //in game
                <div class="d-flex col-9" style="height: 100%;">
                    <InGameTable StatusData="statusData" LargeScreen="largeScreen"></InGameTable>
                </div>
            }

            <div class="col-3" style="padding: 0; height: 100%;"><!-- rankings -->
                @if(statusData!=null){
                    <RankingsComponent GameStatus="@statusData.game_status" PlayerRankings="@statusData.rankings"></RankingsComponent>
                }
            </div>
        </div>

        @if(statusData.game_status=="LOBBY"||statusData.game_status=="IN_GAME_PLAYING"){
            @if(largeScreen){<div style="height: 12px;"></div>}else{<div style="height: 6px;"></div>}
        <div style="height: @calcHeight(1);"><!-- bottom row -->
            @if(statusData.game_status=="LOBBY"){
                <div class="custom-scroller" style="width: 100%; height: 100%;">
                <div class="col-12 card" style="padding: 24px; height: 100%; overflow-y: auto;">

                    @if(IsHost()){
                        <div class="d-flex" style="flex-direction: row;"> <!-- host config panel -->
                            <div style="flex-grow: 1; padding-right: 24px;">
                                <ConfigComponent ConfigData="configData"></ConfigComponent>
                            </div>
                            <div style="width: 1px; background-color: lightgrey;"></div>
                            <div style="flex-grow: 1;">
                                <div style="display: flex; margin-top: 64px;">
                                    <div style="flex-grow: 1"></div>
                                    <SpinButton OnClickCallback="OnStartGameClick" SpinningKey="awaitingStartGame">Start Game</SpinButton>
                                    <div style="flex-grow: 1"></div>
                                </div>
                            </div>
                        </div>
                    }

                    @if(!IsHost()){
                        <p style="text-align: center;">Waiting for host to start game.</p>
                        //todo something to entertain the waiter
                    }
                </div></div>

            }else{
                @if (statusData.in_game_data.card_czar == back.GetPlayerNick()){
                    <p style="text-align: center; width: 100%; padding-top: 36px;">You are the card czar.</p>
                }else{
                    <HandComponent ResponsesRequired="@GetResponsesRequired()" Hand="hand"></HandComponent>
                }
            }
        </div>
        }
    </div>
    }else{ // game completed
        <div style="height: @calcHeight(2);" class="row">
            <GameCompleteComponent StatusData="statusData" LargeScreen="largeScreen"></GameCompleteComponent>
        </div>
    }

    <div style="position: absolute; bottom: 36px; right: 36px;"> <!-- Toasts-->
        <ToastMaster></ToastMaster>
    </div>

    }

</div>


@code {

    [Parameter]
    public string GameId {get; set;}
    
    private StatusData statusData {get;set;} = null;
    private Dictionary<string, string> configData {get;set;} = null;
    private ResponseCard[] hand {get;set;} = null;

    private bool isPortrait => viewHeight > viewWidth;
    private int viewHeight = -1;
    private int viewWidth = -1;
    private bool largeScreen => (viewHeight > 612);
    private bool isFullscreen = false;

    // returns number of cards the player can and should play this sub-round
    private int GetResponsesRequired(){
        if (!IsInGame()) return 0;
        return this.statusData.in_game_data.question.answers_required;
    }

    private string DisplayStatus(string status){
        switch(status){
            case "LOBBY":
                return "Game Lobby";

            case "IN_GAME_PLAYING":
                return "In Game";

            case "IN_GAME_PICKING":
                return "Card Czar picking...";

            case "IN_GAME_WINNER_PICKED":
                return "Winner picked!";

            case "COMPLETED":
                return "Game complete";

            default:
                return "";
        }
    }

    private string getRoundDisplay(){
        if (statusData == null || configData == null || statusData.game_status!="IN_GAME_PLAYING") return "_";

        var round = statusData.in_game_data.round_num;
        var subround = statusData.in_game_data.sub_round_num;

        int playersConnected = 0;
        foreach(PlayerRanking ranking in this.statusData.rankings){
            if (ranking.connected) playersConnected++;
        }
        var subroundLim = subround > playersConnected ? subround : playersConnected;

        return $"Play {subround} of {subroundLim} in Round {round} of {configData["ROUND_LIMIT"]}";
    }
    private string getRoundDisplayCol(){
        if (statusData == null || statusData.game_status!="IN_GAME_PLAYING") return "white";
        return "black";
    }

    private string calcHeight(int section){
        if (statusData == null || viewHeight==-1) return "0";
        var topPadding = largeScreen ? 24 : 6;
        var midPadding = largeScreen ? 12 : 6;
        var topBar = largeScreen ? 80 : 55;
        int heightForMain = viewHeight-topPadding-topBar-midPadding*3;
        var gs = statusData.game_status;
        if (gs=="IN_GAME_PICKING"||gs=="IN_GAME_WINNER_PICKED"||gs=="COMPLETED")
            return $"{heightForMain}px";
        else
            return $"{heightForMain/2}px";
    }

    private string getQuitText(){
        if (statusData != null){
            if (IsInGame()) return "You will be forfeiting the game.";
            
            if (statusData.game_status=="LOBBY"){
                var connectedPlayers = 0;
                foreach(var ranking in statusData.rankings){
                    if (ranking.connected) connectedPlayers++;
                }
                
                if (IsHost() && connectedPlayers>1)
                    return "Another player will be made host.";
            }
        }
        return "You will not be able to rejoin this game.";
    }

    private bool IsInGame(){
        return this.statusData.game_status.StartsWith("IN_GAME");
    }

    private bool IsHost(){
        foreach(var ranking in statusData.rankings){
            if (ranking.nick==back.GetPlayerNick()){
                if (ranking.host)
                    return true;
                break;
            }
        }
        return false;
    }

    protected override async Task OnInitializedAsync(){
        if (!back.PlayerIsRegistered()){
            navMan.NavigateTo("/?gameId="+GameId);
            return;
        }

        setupListeners();
        
        var goodOpen = await back.ConnectToGame(GameId);
        
        if (goodOpen){
            if (Backend.IsDebug())
                Console.WriteLine("Connection opened successfully");
        }else{
            await back.ClearPlayer();
            navMan.NavigateTo(QueryHelpers.AddQueryString("/", 
                new Dictionary<string, string>{["gameId"]= GameId}));
        }
        
    }

    private void setupListeners(){
        obz.Register<StatusMessage>("STATUS", OnStatusUpdate, "Game");
        obz.Register<ConfigMessage>("CONFIG_UPDATED", OnConfigUpdated, "Game");
        obz.Register<ErrorMessage>("ERR", onServerError, "Game");
        obz.Register<RoundPlayingMessage>("ROUND_PLAYING", OnRoundPlaying, "Game");
        obz.Register<BlankMessage>("RESPONSE_PLAYED", OnResponsePlayed, "Game");
        obz.Register<GameKilledMessage>("GAME_KILLED", onGameKilled, "Game");
        obz.Register<RoundPickingMessage>("ROUND_PICKING", onRoundPicking, "Game");
        obz.Register<WinnerPickedMessage>("WINNER_PICKED", onWinnerPicked, "Game");
        obz.Register<BlankMessage>("GAME_COMPLETE", onGameComplete, "Game");
        obz.Register<HandUpdatedMessage>("HAND_UPDATED", onHandUpdated, "Game");
    }

    protected override async Task OnAfterRenderAsync(bool firstRender){
        await refreshMeasures();
        if (firstRender){
            await jsiop.InstallRotationHook(OnRotationChanged);
            await jsiop.InstallFullscreenHook(onFullscreenChanged);
        }
    }

    private async Task OnRotationChanged(){
        await Task.Delay(1000);
        await refreshMeasures();
        base.StateHasChanged();
    }

    private async Task onFullscreenChanged(){
        await Task.Delay(500);
        this.isFullscreen = await jsiop.IsFullscreen();
        await refreshMeasures();
        base.StateHasChanged();
    }

    private async Task refreshMeasures(){
        int[] measures = await jsiop.ViewMeasures();
        this.viewWidth = measures[0];
        this.viewHeight = measures[1];
    }

    private async Task OnLeaveClick(){
        await back.LeaveGame();
        await back.ClearPlayer();
        navMan.NavigateTo("/", true);
    }

    private void OnStartGameClick(){
        wagter.SetState("awaitingStartGame", true);
        back.SendMessage(new BlankMessage("START_GAME"));
    }

    private void OnStatusUpdate(StatusMessage msg){
        this.statusData = msg.data;
        base.StateHasChanged();
    }

    private void onHandUpdated(HandUpdatedMessage msg){
        this.hand = msg.data.cards;
        base.StateHasChanged();
    }

    private void OnConfigUpdated(ConfigMessage msg){
        this.configData = msg.data.config;
        base.StateHasChanged();
    }

    private void onServerError(ErrorMessage msg){
        if (msg.data.info.Contains("start"))
            wagter.SetState("awaitingStartGame", false);
    }

    private void onGameComplete(BlankMessage msg){
        this.statusData.game_status = "COMPLETED";
        base.StateHasChanged();
    }

    private void onRoundPicking(RoundPickingMessage msg){
        obz.Notify("stopTimer", true);
        this.statusData.response_detail = msg.data.response_detail;
        this.statusData.game_status = "IN_GAME_PICKING";
        base.StateHasChanged();
        obz.Notify("startTimer", 90);
    }

    private void onWinnerPicked(WinnerPickedMessage msg){
        obz.Notify("stopTimer", true);
        this.statusData.winning_player = msg.data.winner_nick;
        this.statusData.winning_response_id = msg.data.response_id;
        this.statusData.rankings = msg.data.rankings;
        this.statusData.game_status = "IN_GAME_WINNER_PICKED";
        base.StateHasChanged();
    }

    private void OnResponsePlayed(BlankMessage msg){
        this.statusData.response_detail.count++;
        base.StateHasChanged();
        if (this.statusData.response_detail.count == 1)
            obz.Notify("startTimer", 90);
    }

    private void OnRoundPlaying(RoundPlayingMessage msg){
        wagter.SetState("awaitingStartGame", false);

        this.statusData.in_game_data = msg.data;
        this.statusData.response_detail = new ResponseDetail();
        var oldStatus = this.statusData.game_status;
        this.statusData.game_status = "IN_GAME_PLAYING";

        this.statusData.winning_player = null;
        this.statusData.winning_response_id = -1;

        if (oldStatus == "LOBBY")
            obz.Notify("toast", new ToastData("Game started"));
        else if (oldStatus == "IN_GAME_PICKING")
            obz.Notify("toast", new ToastData("No winner - czar took too long"));

        base.StateHasChanged();
    }

    private void onGameKilled(GameKilledMessage msg){
        obz.Notify("stopTimer", true);
        var reason = msg.data.reason;
        this.statusData.game_status = "COMPLETED";
        obz.Notify("toast", new ToastData($"Game ended: {reason}"));
        base.StateHasChanged();
    }

    private void OnFullscreenClick(){
        jsiop.ToggleFullscreen();
    }

    public void Dispose(){
        obz.Deregister("Game");
    }

}
